----------------------------------------------------------------------------
-- @Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
---@v.1.0.0.0---------------------------------------------------------------
----------------------------------------------------------------------------

nitro = {}
nitro.modDirectory  = g_currentModDirectory;
nitro.buttonDown = false;
nitro.isActive = false;
source(Utils.getFilename("nitroPSUtil.lua", g_currentModDirectory));

function nitro.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(Washable, specializations)
		and SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations)
		and SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function nitro.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", nitro);
	SpecializationUtil.registerEventListener(vehicleType, "onDraw", nitro);
end;

function nitro.registerFunctions(vehicleType)
	SpecializationUtil.registerFunction(vehicleType, "loadExhaustFlames", nitro.loadExhaustFlames);
end;

function nitro.registerOverwrittenFunctions(vehicleType)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "getBrakeForce", nitro.getBrakeForce);
end;

function nitro:loadExhaustFlames()
	if self.spec_motorized.exhaustEffects ~= nil then
		local spec = self.spec_motorized;
		for _, effect in pairs(spec.exhaustEffects) do
			effect.exhaustFlames = {};
			effect.exhaustFlames.isActive = false;	
			local psData = {};
			psData.psFile = "flames/fire.i3d";
			psData.posX = 0; 
			psData.posY = 0;
			psData.posZ = 0;
			psData.worldSpace = false;
			FS19PSUtil.loadParticleSystemFromData(psData, effect.exhaustFlames, nil, false, nil, nitro.modDirectory, effect.node);
			self.hasExhaustFlames = true;
		end;
	end;
end;

function nitro:onUpdate(dt)
	if self.spec_enterable ~= nil then
		if self.hasExhaustFlames == nil then
			self:loadExhaustFlames();
		end;
		if self.spec_enterable.isEntered and self.isActive then
			if self.spec_motorized ~= nil then
				if Input.isKeyPressed(Input.KEY_rctrl) and Input.isKeyPressed(Input.KEY_KP_enter) and not nitro.buttonDown then
					nitro.buttonDown = true;
					nitro.isActive = not nitro.isActive;
				elseif nitro.buttonDown then
					if not Input.isKeyPressed(Input.KEY_rctrl) and not Input.isKeyPressed(Input.KEY_KP_enter) then
						nitro.buttonDown = false;
					end;
				end;
				if nitro.isActive then
						if Input.isKeyPressed(Input.KEY_delete) then --instant brakes (works in air)
							setLinearVelocity(self.components[1].node,0,0,0); 
						end;
					if Input.isKeyPressed(Input.KEY_space) and not (Input.isKeyPressed(Input.KEY_lshift)) then --forward
						local force = 20*self:getTotalMass(true);
						local _,cmY,cmZ = getCenterOfMass(self.rootNode);
						local dirX,_,dirZ = localDirectionToWorld(self.components[1].node,0,0,1);
						addForce(self.components[1].node,dirX*force,0,dirZ*force,0,cmY,cmZ,true);
						if self.hasExhaustFlames ~= nil then
							for _, effect in pairs(self.spec_motorized.exhaustEffects) do
								if not effect.exhaustFlames.isActive then
									ParticleUtil.setEmittingState(effect.exhaustFlames, true, false, false);
									effect.exhaustFlames.isActive = true;
								end;
							end;	
						end;	
					elseif Input.isKeyPressed(Input.KEY_space) and (Input.isKeyPressed(Input.KEY_lshift)) then --reverse
						local force = 20*self:getTotalMass(true);
						local _,cmY,cmZ = getCenterOfMass(self.rootNode);
						local dirX,_,dirZ = localDirectionToWorld(self.components[1].node,0,0,-1);
						addForce(self.components[1].node,dirX*force,0,dirZ*force,0,cmY,cmZ,true);
						if self.hasExhaustFlames ~= nil then
							for _, effect in pairs(self.spec_motorized.exhaustEffects) do
								if not effect.exhaustFlames.isActive then
									ParticleUtil.setEmittingState(effect.exhaustFlames, true, false, false);
									effect.exhaustFlames.isActive = true;
								end;
							end;
						end;
					else
						if self.hasExhaustFlames ~= nil then
							for _, effect in pairs(self.spec_motorized.exhaustEffects) do
								if effect.exhaustFlames.isActive then	
									ParticleUtil.setEmittingState(effect.exhaustFlames, false, false, false);
									effect.exhaustFlames.isActive = false;
								end;
							end;
						end;
					end;
				else
					if self.hasExhaustFlames ~= nil then
						for _, effect in pairs(self.spec_motorized.exhaustEffects) do
							if effect.exhaustFlames.isActive then	
								ParticleUtil.setEmittingState(effect.exhaustFlames, false, false, false);
								effect.exhaustFlames.isActive = false;
							end;
						end;
					end;
				end;
			end;
		end;
	end;
end;

function nitro:getBrakeForce(superFunc)
	local brakeForce = superFunc(self);
	if nitro.isActive then
		if Input.isKeyPressed(Input.KEY_space) then
			brakeForce = 0;
		end;
	end;
	return brakeForce;
end;

function nitro:onDraw(dt)
	if nitro.isActive then
		g_currentMission:addExtraPrintText("Hold the 'Spacebar' to use Nitro!");
	end;
end;