----------------------------------------------------------------------------
-- @Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------

source(Utils.getFilename("nitro.lua", g_currentModDirectory));

nitroRegister = {};
nitroRegister.modDirectory = g_currentModDirectory;
local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");
nitroRegister.version = getXMLString(modDesc, "modDesc.version");

 function installSpec()
	if g_specializationManager:getSpecializationByName("nitro") == nil then
		if nitro == nil then 
			print("ERROR: unable to find source file 'nitro.lua'");
		else 
			for typeName, typeDef in pairs(g_vehicleTypeManager.types) do
				if typeDef ~= nil and (typeName ~= "locomotive") then 
					local isWashable = false;	
					local isAnimated = false;
					local hasEngine = false;
					for name, spec in pairs(typeDef.specializationsByName) do 
						if name == "washable" then 
							isWashable = true;
						elseif name == "animatedVehicle" then 
							isAnimated = true;
						elseif name == "motorized" then 
							hasEngine = true;
						end;
					end;
					if isWashable and isAnimated and hasEngine then
						 if typeDef.specializationsByName["nitro"] == nil then
							table.insert(typeDef.specializations, nitro);
							table.insert(typeDef.specializationNames, "nitro");	
							typeDef.specializationsByName["nitro"] = nitro;
						end;
					end;
				end;
			end;
		end;	
	end;
end;

TypeManager.validateTypes = Utils.appendedFunction(TypeManager.validateTypes, installSpec);